#include <opencv2/photo/photo.hpp>
#include <opencv2/core/core.hpp>
#include <armadillo>

using namespace cv;

Mat denoise_arma(Mat src, float alpha) {
	
	Mat input_n;
	input_n = src/255;

	// Parametros algoritmo
	//float alpha = 2.5;
	float dt = 0.01;
	float sigma = 0.01f;

	// Parametros convolucion
	Mat kernelx = (Mat_<float>(1,2)<<-1, 1);
	Mat kernely = (Mat_<float>(2,1)<<-1, 1);
	Point anchorx_r = Point( -1, 0 );
	Point anchory_r = Point( 0, -1 );
	Point anchorx_l = Point( 0, 0 );
	Point anchory_l = Point( 0, 0 );
	double delta = 0;
	int ddepth = -1;

	// Inicializacion matrices
	Mat fx(src.rows,src.cols,CV_32F);
	Mat fy(src.rows,src.cols,CV_32F);
	Mat Module(src.rows,src.cols,CV_32F);
	Mat V1(src.rows,src.cols,CV_32F);
	Mat V2(src.rows,src.cols,CV_32F);
	Mat U1(src.rows,src.cols,CV_32F);
	Mat U2(src.rows,src.cols,CV_32F);
	Mat W(src.rows,src.cols,CV_32F);

	// Armadillo matrix
	arma::fmat arma_W( W.ptr<float>(), W.rows, W.cols, false, true );
	arma::fmat arma_src( src.ptr<float>(), src.rows, src.cols, false, true );
	arma::fmat arma_inputn( input_n.ptr<float>(), input_n.rows, input_n.cols, false, true );
	arma::fmat arma_fx( fx.ptr<float>(), fx.rows, fx.cols, false, true );
	arma::fmat arma_fy( fy.ptr<float>(), fy.rows, fy.cols, false, true );
	arma::fmat arma_Module( fy.ptr<float>(), Module.rows, Module.cols, false, true );
	arma::fmat arma_U1( U1.ptr<float>(), U1.rows, U1.cols, false, true );
	arma::fmat arma_U2( U2.ptr<float>(), U2.rows, U2.cols, false, true );
	arma::fmat arma_V1( V1.ptr<float>(), V1.rows, V1.cols, false, true );
	arma::fmat arma_V2( V2.ptr<float>(), V2.rows, V2.cols, false, true );

	for (int i = 0; i < 25; i++) {	
		
		filter2D(input_n, fx, ddepth, kernelx, anchorx_r, delta, BORDER_REPLICATE );
		filter2D(input_n, fy, ddepth, kernely, anchory_r, delta, BORDER_REPLICATE );

		arma_Module = sqrt((arma_fx%arma_fx + arma_fy%arma_fy)+sigma);

		arma_U1 = arma_fx/arma_Module;
		arma_U2 = arma_fy/arma_Module;

		filter2D(U1, V1, ddepth, kernelx, anchorx_l, delta, BORDER_REPLICATE );
		filter2D(U2, V2, ddepth, kernely, anchory_l, delta, BORDER_REPLICATE );

		arma_W = arma_V1 + arma_V2 + arma_src*(alpha/255.0) - arma_inputn*alpha;

		arma_inputn += arma_W*dt;

	}

	return input_n.mul(255);	

}
