#include <opencv2/photo/photo.hpp>
#include <opencv2/core/core.hpp>
#include <eigen3/Eigen/Dense>
#include <eigen3/Eigen/Core>

using namespace cv;

Mat denoise_eigen(Mat src, float alpha) {
	
	Mat input_n;
	input_n = src/255;

	// Parametros algoritmo
	//float alpha = 2.5;
	float dt = 0.01;
	float sigma = 0.01f;

	// Parametros convolucion
	Mat kernelx = (Mat_<float>(1,2)<<-1, 1);
	Mat kernely = (Mat_<float>(2,1)<<-1, 1);
	Point anchorx_r = Point( -1, 0 );
	Point anchory_r = Point( 0, -1 );
	Point anchorx_l = Point( 0, 0 );
	Point anchory_l = Point( 0, 0 );
	double delta = 0;
	int ddepth = -1;

	// Inicializacion matrices
	Mat fx(src.rows,src.cols,CV_32F);
	Mat fy(src.rows,src.cols,CV_32F);
	Mat Module(src.rows,src.cols,CV_32F);
	Mat U1(src.rows,src.cols,CV_32F);
	Mat U2(src.rows,src.cols,CV_32F);
	Mat V1(src.rows,src.cols,CV_32F);
	Mat V2(src.rows,src.cols,CV_32F);
	Mat W(src.rows,src.cols,CV_32F);

	// Eigen map
	Eigen::Map<Eigen::Matrix<float, Eigen::Dynamic, Eigen::Dynamic, Eigen::RowMajor> > Module_mappedMat ((float *)Module.data, src.rows, src.cols);
	Eigen::Map<Eigen::Matrix<float, Eigen::Dynamic, Eigen::Dynamic, Eigen::RowMajor> > fx_mappedMat ((float *)fx.data, src.rows, src.cols);
	Eigen::Map<Eigen::Matrix<float, Eigen::Dynamic, Eigen::Dynamic, Eigen::RowMajor> > fy_mappedMat ((float *)fy.data, src.rows, src.cols);
	Eigen::Map<Eigen::Matrix<float, Eigen::Dynamic, Eigen::Dynamic, Eigen::RowMajor> > U1_mappedMat ((float *)U1.data, src.rows, src.cols);
	Eigen::Map<Eigen::Matrix<float, Eigen::Dynamic, Eigen::Dynamic, Eigen::RowMajor> > U2_mappedMat ((float *)U2.data, src.rows, src.cols);
	Eigen::Map<Eigen::Matrix<float, Eigen::Dynamic, Eigen::Dynamic, Eigen::RowMajor> > V1_mappedMat ((float *)V1.data, src.rows, src.cols);
	Eigen::Map<Eigen::Matrix<float, Eigen::Dynamic, Eigen::Dynamic, Eigen::RowMajor> > V2_mappedMat ((float *)V2.data, src.rows, src.cols);
	Eigen::Map<Eigen::Matrix<float, Eigen::Dynamic, Eigen::Dynamic, Eigen::RowMajor> > W_mappedMat ((float *)W.data, src.rows, src.cols);
	Eigen::Map<Eigen::Matrix<float, Eigen::Dynamic, Eigen::Dynamic, Eigen::RowMajor> > inputn_mappedMat ((float *)input_n.data, src.rows, src.cols);
	Eigen::Map<Eigen::Matrix<float, Eigen::Dynamic, Eigen::Dynamic, Eigen::RowMajor> > src_mappedMat ((float *)src.data, src.rows, src.cols);

	for (int i = 0; i < 25; i++) {	
		
		filter2D(input_n, fx, ddepth, kernelx, anchorx_r, delta, BORDER_REPLICATE );
		filter2D(input_n, fy, ddepth, kernely, anchory_r, delta, BORDER_REPLICATE );

		Module_mappedMat = ((fx_mappedMat.cwiseProduct(fx_mappedMat) + fy_mappedMat.cwiseProduct(fy_mappedMat)).array()+sigma).cwiseSqrt();

		U1_mappedMat = fx_mappedMat.cwiseQuotient(Module_mappedMat);
		U2_mappedMat = fy_mappedMat.cwiseQuotient(Module_mappedMat);

		filter2D(U1, V1, ddepth, kernelx, anchorx_l, delta, BORDER_REPLICATE );
		filter2D(U2, V2, ddepth, kernely, anchory_l, delta, BORDER_REPLICATE );

		W_mappedMat = V1_mappedMat + V2_mappedMat + src_mappedMat*(alpha/255.0f) - inputn_mappedMat*alpha;

		input_n = input_n + W.mul(dt);
	}

	return input_n.mul(255);	

}
