#include <opencv2/photo/photo.hpp>
#include <opencv2/core/core.hpp>

using namespace cv;

Mat denoise_opencv(Mat src, float alpha) {
	
	Mat input_n;
	input_n = src/255;

	// Parametros algoritmo
	//float alpha = 2.5;
	float dt = 0.01;
	float sigma = 0.01f;

	// Parametros convolucion
	Mat kernelx = (Mat_<float>(1,2)<<-1, 1);
	Mat kernely = (Mat_<float>(2,1)<<-1, 1);
	Point anchorx_r = Point( -1, 0 );
	Point anchory_r = Point( 0, -1 );
	Point anchorx_l = Point( 0, 0 );
	Point anchory_l = Point( 0, 0 );
	double delta = 0;
	int ddepth = -1;

	// Inicializacion matrices
	Mat fx(src.rows,src.cols,CV_32F);
	Mat fy(src.rows,src.cols,CV_32F);
	Mat Module(src.rows,src.cols,CV_32F);
	Mat U1(src.rows,src.cols,CV_32F);
	Mat U2(src.rows,src.cols,CV_32F);
	Mat V1(src.rows,src.cols,CV_32F);
	Mat V2(src.rows,src.cols,CV_32F);
	Mat W(src.rows,src.cols,CV_32F);

	for (int i = 0; i < 25; i++) {	
		
		filter2D(input_n, fx, ddepth, kernelx, anchorx_r, delta, BORDER_REPLICATE );
		filter2D(input_n, fy, ddepth, kernely, anchory_r, delta, BORDER_REPLICATE );

		Module = fx.mul(fx) + fy.mul(fy) + sigma;
		sqrt(Module, Module);

		U1 = fx / Module;
		U2 = fy / Module;

		filter2D(U1, V1, ddepth, kernelx, anchorx_l, delta, BORDER_REPLICATE );
		filter2D(U2, V2, ddepth, kernely, anchory_l, delta, BORDER_REPLICATE );

		W = V1 + V2 + src.mul(alpha/255) - input_n.mul(alpha);

		input_n = input_n + W.mul(dt);
	}

	return input_n.mul(255);	

}
